

#include "allstuff.h"


struct tRect {
	int x1,y1,x2,y2;
};



BITMAP *gfx_frame[0x10000];
int gfx_spot_x[0x100000];
int gfx_spot_y[0x100000];


char raw_buff[0x100000];

SAMPLE *samp[16];



SAMPLE *load_raw(char *path)
{
	FILE *fp = fopen(path,"rb");
	if(!fp)
		return NULL;
	int len = fread(raw_buff,1,sizeof(raw_buff),fp);
	fclose(fp);

	SAMPLE *smp = create_sample(8,0,44100,len);
	if(!smp)
		return NULL;

	int i;
	for(i=0;i<len;i++)
		raw_buff[i]^=0x80;
	memcpy(smp->data,raw_buff,len);

	return smp;
}


void load_frame(int fr,int spot_x,int spot_y)
{
	char buff[100];
	sprintf(buff,"data/%c%c.bmp",INT2SEQ(fr),INT2FRAME(fr));
	gfx_frame[fr] = load_bitmap(buff,NULL);
	if(!gfx_frame[fr])
		return;

	sprintf(buff,"data/%c%c.xy",INT2SEQ(fr),INT2FRAME(fr));
	FILE *fp = fopen(buff,"rt");
	if(fp)
	{
		int x1,y1,x2,y2;
		fscanf(fp,"%d%d%d%d",&x1,&y1,&x2,&y2);
		gfx_spot_x[fr]=spot_x-x1;
		gfx_spot_y[fr]=spot_y-y1;

		fclose(fp);
	}
}


void load_all_frames()
{
	int i,j;
	for(i=0;i<4;i++)
		for(j=0;j<7;j++)
			load_frame(FRAME2INT("rdlu"[i],j+'0'),428-17,406-15);
			
	load_frame(STR2INT("s0"),428-17,406-15);
	load_frame(STR2INT("s1"),428-17,406-15);
	load_frame(STR2INT("s2"),428-17,406-15);
	load_frame(STR2INT("s3"),428-17,406-15);
	load_frame(STR2INT("t0"),428-17,406-15);
	
	load_frame(STR2INT("a0"),0,0);
	load_frame(STR2INT("w0"),0,0);
	
	for(i=0;i<3;i++)
		for(j=0;j<11;j++)
			load_frame(FRAME2INT("efm"[i],"123456789ab"[j]),0,0);
			
			
	samp[0] = load_raw("snd/ding");
	samp[1] = load_raw("snd/fall");
	samp[2] = load_raw("snd/laser");
	samp[3] = load_raw("snd/laser2");
	samp[4] = load_raw("snd/punch");
	samp[5] = load_raw("snd/jump");
}


void draw_frame(BITMAP *dest,int fr,int xp,int yp)
{
	if(!gfx_frame[fr&FRAME_MASK])
		return;
	BITMAP *g = gfx_frame[fr&FRAME_MASK];
	masked_blit(g,dest,0,0,xp-gfx_spot_x[fr&FRAME_MASK],yp-gfx_spot_y[fr&FRAME_MASK],g->w,g->h);
}


void play_samp(int id)
{
	play_sample(samp[id],255,128,1000,0);
}

