

#include "allstuff.h"




#define QPF(f)		al_QPF(f)
#define QPC(c)		al_QPC(c)




volatile int timer;



void my_timer()
{
	timer++;
}

void al_QPF(void *f)
{
	*(long long*)f = 200;
	install_int_ex(my_timer,BPS_TO_TIMER(200));
	timer = 0;
}

void al_QPC(void *c)
{
	*(long long*)c = timer;
}



void hud_text(BITMAP *buff,char *text,int x,int y,int col=0xFFFFFF,int s=2,int c2=0)
{
	static BITMAP *hud1,*hud2;

	if(!hud1) hud1 = create_bitmap(320,20);
	if(!hud2) hud2 = create_bitmap(320,200);
	int l=strlen(text)*8+2;

	text_mode(-1);
	rectfill(hud1,0,0,l,10,0xFF00FF);
	rectfill(hud2,0,0,l*s,10*s,0xFF00FF);
	textout(hud1,font,text,0,1,c2);
	textout(hud1,font,text,1,0,c2);
	textout(hud1,font,text,2,1,c2);
	textout(hud1,font,text,1,2,c2);
	textout(hud1,font,text,1,1,col);
	stretch_blit(hud1,hud2,0,0,l,10,0,0,l*s,10*s);
	masked_blit(hud2,buff,0,0,x,y,l*s,10*s);
}


void do_menu(BITMAP *dest)
{
	int i;
	char buff[100];
	for(i=0;i<5;i++)
	{
		buff[0]="SNAKE"[i];
		buff[1]=0;
		hud_text(dest,buff,(1024-400)/2+i*80,128,0x008000,12,0x002000);
	}
	
	hud_text(dest,"PRESS ENTER TO START",(1024-20*16)/2,400,0xFFFF00,2,0x004000);
}


int main()
{
	allegro_init();
	install_keyboard();
	install_timer();

	install_sound(DIGI_AUTODETECT,MIDI_NONE,"");

	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT,1024,768,0,0);
	
	clear(screen);
	BITMAP *buff = create_bitmap(SCREEN_W,SCREEN_H);


	FILE *fp = fopen("hscore.dat","rb");
	if(fp)
	{
		fread(&high_score,1,sizeof(int),fp);
		fclose(fp);
	}
	
	load_all_frames();

	start_demo_mode();


	long long t0,t1,fq;
	QPF(&fq);
	QPC(&t1);
	t0=t1;

	char b[100];
	while(true)
	{
		clear(buff);
		show_objects(buff);
		
		if(cheat_mode)
			score = 0;

		sprintf(b,"SC:%08d",score);
		hud_text(buff,b,0,0);
		
		if(score>high_score)
			high_score = score;
		sprintf(b,"HI:%08d",high_score);
		hud_text(buff,b,(1024-11*16-2),0);

		if(demo_mode)
		{
			do_menu(buff);
		}
 		else
		{
			if(cheat_mode)
				hud_text(buff,"TROLL!!!!",(1024-9*16)/2,0,0xFF0000);
	  		if(game_over)
 			{
				hud_text(buff,"GAME OVER",(1024-9*16)/2,(768-16)/2);
	 		}
			else if(stage_text>0)
			{
				sprintf(b,"STAGE %02d",stage);
				hud_text(buff,b,(1024-8*16)/2,768/2+48);
			}
		}

		vsync();
		blit(buff,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		
		QPC(&t1);
		float delta = float(t1-t0)/fq;
		t0=t1;
		
		int cnt = int(ceil(delta))+1;
		if(cnt<1) cnt=1;
		delta/=cnt;
		if(cnt>20) cnt=20;
		
		int ch;
		if(keypressed())
		{
			ch=readkey();
//			if(ch>='1' && ch<='5')
//				play_samp(ch-'1');
			if(!demo_mode)
			{
				if((ch>>8)==KEY_ESC)
					start_demo_mode();
			}
			else
			{
				if((ch>>8)==KEY_ENTER)
					start_new_game();
				if((ch>>8)==KEY_ESC)
					break;
 			}
		}

		while(cnt-->0)
			think_objects(delta);
			
		check_endgame();
	}
	

	fp = fopen("hscore.dat","wb");
	if(fp)
	{
		fwrite(&high_score,1,sizeof(int),fp);
		fclose(fp);
	}

	
	return 0;
}
END_OF_MAIN()

