

#include "allstuff.h"



#include <queue>
using namespace std;



struct tReached {
	int xp,yp,dist,fdir;
	bool final;
	
	bool operator <(const tReached &r) const
	{
		return dist>r.dist;
	}
};


typedef int (*pPathFun)(int xp,int yp);


priority_queue<tReached> reached;
int min_dist[25][25];




void path_enter(int xp,int yp,int dist,int fdir,pPathFun fun)
{
	bool final = false;

	if(fun)
	{
		int dc = fun(xp,yp);
		if(dc==0)
			return;
		final = (dc<0);
		if(dc<0) dc=-dc;
		dist+=dc;
	}
	else
		dist++;

	if(xp<0 || xp>=25 || yp<0 || yp>=25)
		return;
	if(min_dist[xp][yp]<=dist)
		return;
	min_dist[xp][yp]=dist;
	
	tReached r;
	r.xp = xp;
	r.yp = yp;
	r.dist = dist;
	r.fdir = fdir;
	r.final = final;
	reached.push(r);
}

int path_find(int sx,int sy,pPathFun fun)
{
	memset(min_dist,0x7F,sizeof(min_dist));
	while(!reached.empty())
		reached.pop();

	path_enter(sx,sy,0,0,NULL);
	
	int i;
	for(i=1;i<=4;i++)
		path_enter(sx+DX[i],sy+DY[i],0,i,fun);
		
	tReached r;
	r.final = false;
	while(!reached.empty())
	{
		r = reached.top();
		reached.pop();

		if(r.final)
			break;

		if(r.dist>min_dist[r.xp][r.yp])
			continue;
			
		for(i=1;i<=4;i++)
			path_enter(r.xp+DX[i],r.yp+DY[i],r.dist,r.fdir,fun);
	}
	
	if(r.final)
		return r.fdir;

	return 0;
}

